// (C)opyright 2021-07-15 Dirk Holtwick, holtwick.it. All rights reserved.
export function getStackLlocationList(stack) {
    var _a, _b;
    if (typeof stack !== "string")
        return [];
    // console.log("stack", stack)
    return (((_b = (_a = stack === null || stack === void 0 ? void 0 : stack.split("\n")) === null || _a === void 0 ? void 0 : _a.map((rawLine) => {
        let m = rawLine.match(/^\s+at.*(\((.*)\)|file:\/\/(.*)$)/);
        if (m) {
            let line = m[3] || m[2];
            if (line.endsWith(")"))
                line = line.slice(0, -1);
            return line;
        }
    })) === null || _b === void 0 ? void 0 : _b.filter((v) => v != null)) || []);
}
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
export function getSourceLocation(level = 2, stripCwd = true) {
    var _a;
    let stack = new Error().stack || "";
    let line = (_a = getStackLlocationList(stack)) === null || _a === void 0 ? void 0 : _a[level];
    if (line && stripCwd) {
        if (line.startsWith("file://")) {
            line = line.substr("file://".length);
        }
        if (line.startsWith(process.cwd())) {
            line = line.substr(process.cwd().length + 1);
        }
    }
    return line || "";
}
//# sourceMappingURL=log-util.js.map